!=====================================================================
! $B29EY7W;;%5%V%k!<%A%s(B
! 2002/01/19 
! 2002/01/24 $B$J$<$+(B 600 km $BCOE@$G29EY>e>:(B
!
!=====================================================================
module T_pack
  use prm                                              ! $BDj?t;2>H7?%b%8%e!<%k(B
  use common_variable, only: &                         ! $BJQ?t;2>H7?%b%8%e!<%k(B
       & depend_T_prm,        &
       & zk, delta_zk_j, delta_zk_j1_2, &
       & Q, A_0
       
  implicit none

  private 
  public get_T               ! $B29EYJ,I[$rF3=P(B
  public funct_A             ! $B29EY0MB8%Q%i%a!<%?4X?t(B

contains
!=====================================================================
! $B29EYJ,I[7W;;(B
! A T^{k+1} = B
! A: $B78?t9TNs(B(n x n $B9TNs(B)
! T: k+1 $B$K$*$1$k29EYG[Ns(B(n $B<!85$N2r%Y%/%H%k(B. $B$3$N>l9g$O(B T(1:km-1))
! B: k $B$K$*$1$kJQ?t$rBeF~$7$??tCM(B(n $B<!85$N<BDj?t%Y%/%H%k(B)
!
! $B9TNs7W;;$K$OIY;NDL(B Fortrun  ssl II lax $B%5%V%k!<%A%s(B($B%/%i%U%HK!(B)$B$rMQ$$$k(B
! T $B$O$"$k(B i $B$K$D$$$F$NCM(B
!=====================================================================
subroutine get_T(h_2, h_1, u_1, w_2, T_1, T_2)
  real(8)   , intent(in)  :: h_2(0:im-1)        ! $B<!%9%F%C%W$NI98|%W%m%U%!%$%k(B
  real(8)   , intent(in)  :: h_1(0:im-1)        ! $BA0%9%F%C%W$NI98|%W%m%U%!%$%k(B
  real(8)   , intent(in)  :: u_1(0:im-1, 0:km)  ! $B?eJ?B.EY(B
!  real(8)   , intent(in)  :: u_2(0:im-1, 0:km)  ! $B?eJ?B.EY(B
  real(8)   , intent(in)  :: w_2(0:im-1, 0:km)  ! $B1tD>B.EY(B
  real(8)   , intent(inout)  :: T_1(0:im-1, 0:km)  ! k $B$K$*$1$k29EY(B
  real(8)   , intent(out) :: T_2(0:im-1, 0:km)  ! k+1 $B$K$*$1$k29EY(B

  real(8)                 :: b(0:im-1, 0:km)    ! $BDj?t%Y%/%H%k72(B

  real(8)                 :: a_dwn(2:km, 0:im-1)
  real(8)                 :: a_cnt(1:km, 0:im-1)
  real(8)                 :: a_up(1:km-1, 0:im-1)

! i $B$K$*$1$kCM$r5a$a$k$?$a$NJQ?t(B  
  real(8)                 :: b_i(1:km)          ! i $B$G$NDj?t%Y%/%H%k(B

  real(8)                 :: sbd(2:km)        ! $B2<I{BP3QMWAG(B
  real(8)                 :: D(1:km)          ! $BBP3QMWAG(B
  real(8)                 :: spd(1:km-1)      ! $B>eI{BP3QMWAG(B


! $BIY;NDL(B ssl II $B$KI,MW$J%Q%i%a!<%?(B
  real(8)                 :: epsz      ! $B%T%\%C%H$NAjBPNmH=DjCM(B
  real(8)                 :: is        !
  real(8)                 :: vw(0:km)! $B:n6HNN0h(B
  real(8)                 :: ip(0:km)! $B:n6HNN0h(B
  integer                 :: icon      ! $B%3%s%G%#%7%g%s%3!<%I(B
  integer,parameter       :: isw=1       ! $B@)8f>pJs(B($BF~NO(B) l $BAH$NJ}Dx<0(B

  integer                 :: i , j!, k
  integer                 :: dif_bound !$B1tD>3H;6$N?eJ?6-3&(B 
  integer                 :: ice_bound !$BI9$N?eJ?6-3&(B
  
  epsz= epsilon(0.0)

! $B?7$?$KI9$N$G$-$?29EY$N@_Dj(B(T_s $B$H$9$k(B)
  do i = 0, im-1
     if(h_1(i) == 0.0 .and.h_2(i) > 0.0) then
        T_1(i, 0:km) = T_s
        ice_bound = i + 1
     end if
  end do


! $B78?t9TNs$r:n@.(B
  call make_matrix(h_2, h_1, u_1, w_2, a_dwn, a_cnt, a_up)


! $B4{CN$N%G!<%?$+$iDj?t%Y%/%H%k72(B b $B$r;;=P(B
  call make_vector(u_1, T_1, b)


! $BI98|$,$J$$NN0h$NH=Dj(B($B9TNs$N7W;;$r$=$NNN0h$+$i9T$o$J$$$?$a(B)

  do i = 0, im-1
     if( h_2(i) * zk(1) < epsz ) then
        dif_bound  = i-1             ! $BI9>2?eJ?NN0h6-3&(B
!        write(*, *) dif_bound
        exit
     end if
  end do


  do i = 0, dif_bound

     b_i = b(i, 1:km)                  ! i $B$K$*$1$kDj?t%Y%/%H%k(B b_i$B$KCV$-49$($k(B
     
     ! $B<B(B 3 $B9`$r8F$S=P$9(B.
     sbd = a_dwn(2:km, i)     ! $B2<I{BP3QMWAG(B
     D   = a_cnt(1:km, i)     ! $BBP3QMWAG(B
     spd = a_up(1:km-1,  i)     ! $B>eI{BP3QMWAG(B

     


!     if (i == dif_bound) then
!        do j = 1, km
!           write(*,*) sbd(j), D(j), spd(j-1)
!        end do
!     end if

! $B1tD>3H;6$NL58z2=(B     
       sbd = 0.0D0
       spd = 0.0D0
       D = 1.0D0

! $B<B(B 3 $B9`9TNs$NO"N)(B 1 $B<!J}Dx<0(B($B%,%&%9>C5nK!(B)$B$r2r$/(B
!    LAPACK $B$r;HMQ$7$?>l9g(B
!    call dgtsv(km+1, 1, sbd, D, spd, b_i, km+1, icon)

!    $BIY;NDL2J3XMQ%5%V%k!<%A%s%i%$%V%i%j!<(B ssl2 $B$r;HMQ$7$?>l9g(B
     call dltx(sbd, D, spd, km, b_i, epsz, isw, is, ip, vw, icon)

     T_2(i, 1:km) = b_i                   ! $B=PNO$5$l$k(B b_i $B$,2r(B
     T_2(i, 0)    = b(i, 0)

     if(icon >= 20000)  then
        write(*, *) icon
        T_2(i,1:km) = b(i, 1:km)
        dif_bound = i
        exit
     endif
  end do

  T_2(:, km) = T_s


!  T_2(dif_bound:im-1, :) =  b(dif_bound:im-1, :)
  T_2(dif_bound+1:im-1, :) =  b(dif_bound+1:im-1, :)
!  T_2(ice_bound:im-1, :) =  b(ice_bound:im-1, :)

!  write(*, *)dif_bound, ice_bound


end subroutine get_T


!=====================================================================
! $B78?t9TNs(B matrix $B$r:n@.(B
! $B$OI,MW$J$7(B.
! $B78?t9TNs$O(B (km-2 x km-2) $B$N(B 2 $B<!9TNs(B
!
! a_{j-1} = $B&$(Bt V/h(i) $B&B(B/$B&$&F(B_{j-1/2} 
!         - (k/$B&Q(Bc_p)$B&$(Bt/(h(i))^2 * 2/($B&$&F(B_j $B&$&F(B_{j-1/2})
! a_{j}   = 1 + $B&$(Bt V/h(i) ($B&A(B/$B&F(B_{j+1/2} - $B&B(B/$B&F(B_{j-1/2})
!         + (k/$B&Q(Bc_p)$B&$(Bt/(h(i))^2 * 2/$B&$&F(B_j (1/$B&$&F(B_{j+1/2} - 1/$B&$&F(B_{j-1/2})
! a_{j+1} = - $B&$(Bt V/h(i) $B&A(B/$B&$&F(B_{j-1/2} 
!         - (k/$B&Q(Bc_p)$B&$(Bt/(h(i))^2 * 2/($B&$&F(B_j $B&$&F(B_{j+1/2})
! 
!=====================================================================
subroutine make_matrix(h_2, h_1, u, w, a_dwn, a_cnt, a_up) 
  real(8), intent(in)  :: h_2(0:im-1)                   ! $B<!%9%F%C%W$NI98|(B
  real(8), intent(in)  :: h_1(0:im-1)                   ! $BA0%9%F%C%W$NI98|(B
  real(8), intent(in)  :: u(0:im-1, 0:km)               ! $B?eJ?B.EY(B
  real(8), intent(in)  :: w(0:im-1, 0:km)               ! $B1tD>B.EY(B

  real(8), intent(out) :: a_dwn(2:km, 0:im-1)           ! T_{j-1} $B$N78?t(B
  real(8), intent(out) :: a_cnt(1:km, 0:im-1)           ! T_{j}   $B$N78?t(B
  real(8), intent(out) :: a_up(1:km-1, 0:im-1)         ! T_{j+1} $B$N78?t(B
 
  real(8)              :: delta
  real(8)              :: V(0:km, 0:im-1) 
  integer              :: i, j                          ! do $BJQ?t(B

  a_dwn = 0.
  a_cnt = 0.
  a_up = 0.
  delta = epsilon(0.0)                                  ! INF $BMWAG$r$J$/$9$?$a(B

  V = keisu_1(h_2, h_1, u, w)                           ! $B78?t9TNs$N0lIt(B
  
  do i =0, im-1

! T_{j-1}$B$N78?t(B
     do j = 2, km     !$B6-3&NN0h$OJL$G7W;;(B
        a_dwn(j, i)  = & !dt * V(j, i)/(h_2(i)+ delta)          &
             !&  * beta(j) /delta_zk_j1_2(j-1)                  &
             & - dt /(h_2(i)**2) * k_ice /(rho * c_p)  &
             & * 1.0D0/(delta_zk_j1_2(j) * delta_zk_j(j-1))
     end do

     
  ! T_{j} $B$N78?t(B
     do j = 2, km
        a_cnt(j, i)  = 1.0D0                                       &
             &  + dt /(h_2(i)**2) * k_ice /(rho * c_p)          &
             &  * 1.0D0/delta_zk_j1_2(j) * &
             & (1.0D0/delta_zk_j(j) + 1.0D0/delta_zk_j(j-1))
     end do
     a_cnt(1, i) = 1.0D0                                           &
              & + dt/(h_2(i)**2) *k_ice /(rho * c_p)               &
              & * 1.0D0/delta_zk_j1_2(1)                           &
              & * 1.0D0/delta_zk_j(1)
!     write(*, *)a_cnt(1, i)
! $B8E$$@_Dj(B    
!     a_cnt(0, i)  = 1.0D0 + dt/(h_2(i)**2) * k_ice /(rho * c_p)   &
!          &       * 1.0D0/(delta_zk_j1_2(0) * delta_zk_j(0))


  ! T_{j+1}$B$N78?t(B
     do j = 1, km-1
        a_up(j, i)  = & !- dt * V(j, i)/(h_2(i)+ delta)           &
             !&        * alpha(j)/delta_zk_j1_2(j)   &
             &  - dt /(h_2(i)**2) * k_ice /(rho * c_p)              &
             &  * 1.0D0/(delta_zk_j(j) * delta_zk_j1_2(j))
     end do
  end do

end subroutine make_matrix
!=====================================================================
! $BDj%Y%/%H%k$N;;=P(B
! b_j = T_{i,j}- dt/dx * u_{ij} * (T_{i+1, j} - T_{i-1,j})/2 
! u $B$O85$OH>3J;RE@$J$N$GJ?6Q$r<h$C$F$$$k(B.
! k $B$K$*$1$k?eJ?0\N.9`(B + $BG4@-9`(B
! $B8=CJ3,$G$OG4@-9`$OL5;k(B
! 
! $BCO3LG.N.NL(B $B&C$NM?$(J}(B
!     
!=====================================================================
subroutine make_vector(u, T, b)
  real(8), intent(in)    :: u(0:im-1, 0:km)   ! $B?eJ?B.EY(B
  real(8), intent(in)    :: T(0:im-1, 0:km)   ! $B29EY(B
  real(8), intent(out)   :: b(0:im-1, 0:km) ! $BDj?t%Y%/%H%k72(B(0--im-1)

  integer                :: i, j              ! do $BJQ?t(B

  ! x = 0 $B$G$O(B u_{1/2} = - u_{-1/2} $B$NCM$rMQ$$$k(B
  ! $B$h$C$F(B T(1,:), T(-1,:)$B$N9`$O(B 0
!    b(0, :) =  T(0, 0:km)

  do i = 0, im-1
     do j = 1, km 
        b(i, j) =                                     &
             ! $BJ]B87A<0$NCf?4:9J,$b%@%a(B
             !&   - dt/dx                              &
             !&     *( u(i, j)*( T(i+1, j) + T(i, j) )/2.   &
             !&        - u(i-1, j) * ( T(i, j) + T(i-1,j) )/2. ) &
             !&    + T(i,j)
             ! $BCf?4:9J,$O$@$a(B 
             !&   -(u(i+1, j) +u(i, j))/2. *dt *         &
             !&        (T(i, j) - T(i-1,j))/dx + T(i,j)
             ! $BIw>e:9J,$rMQ$$$k(B.
             ! $B%F%9%H$N$?$a?eJ?0\N.$O@Z$k(B.
             &  -((u(i+1, j) + u(i, j))/2.0D0 + &
             &  abs((u(i+1, j) + u(i, j))/2.0D0))/2.0D0 &
             &   * (T(i, j) - T(i-1,j)) * dt/dx              &
             &  - ((u(i+1, j) +  u(i, j))/2.0D0 - &
             &  abs((u(i+1, j) + u(i, j))/2.0D0))/2.0D0 &
             &   * (T(i+1, j) - T(i,j)) * dt/dx              &
             &   + T(i,j)
     end do
     ! u(:, 0) = 0 $B$h$j(B b(i, 0) = T(i, j) + $B&A(B
     b(i, 0) =  & !T(i,0) =
             & T(i, 1) - delta_zk_j(0) *gamma/k_ice
  end do
end subroutine make_vector

!=====================================================================
! $B78?t9TNs$r5a$a$k$?$a$N4X?t(B1
! keisuu_1 = $B&F(B $B"_(Bh/$B"_(Bt + u $B&F"_(Bh/$B"_(Bx - w
!=====================================================================
function  keisu_1(h_2, h_1, u, w)
  real(8)    , intent(in)  :: h_2(0:im-1)               ! t+1 $B$K$*$1$kI98|(B
  real(8)    , intent(in)  :: h_1(0:im-1)               ! t   $B$K$*$1$kI98|(B
  real(8)    , intent(in)  :: u(0:im-1, 0:km)           ! $B?eJ?B.EY(B
  real(8)    , intent(in)  :: w(0:im-1, 0:km)           ! $B1tD>B.EY(B
  real(8)                  :: keisu_1(0:km, 0:im-1)   ! $B5a$a$k4X?t(B

  integer                  ::  i, j                     ! do $BJQ?t(B
  

!  write(*,*)'i, j, V, u, w'   
  do i = 1, im-1
     do j = 1, km
        keisu_1(j, i) =  zk(j) * (h_2(i) - h_1(i))/dt              &
             &        + zk(j) * (u(i, j) + u(i-1, j))/2            &
             &        * (h_2(i+1) - h_2(i-1))/(2 * dx)             !&
!             &        - (alpha(j) * w(i,j) + beta(j) *w(i, j-1))

     end do
        keisu_1(0, i) =  zk(0) * (h_2(i) - h_1(i))/dt
  end do

end function keisu_1

!=====================================================================
! $B29EY0MB8%Q%i%a!<%?4X?t$NF3=P(B
! 2002/01/26
!=====================================================================
function funct_A(T)
  real(8), intent(in) :: T(0:im-1, 0:km)
  real(8)             :: funct_A(0:im-1, 0:km)
  
  integer             :: i,j
  do i = 0, im-1
     do j = 0, km

        call depend_T_prm(T(i,j), A_0, Q)
        funct_A(i, j) = A_0 * exp(-Q/(R * T(i, j)))
     end do
  end do

end function funct_A


end module T_pack


